MainProgram:
  gosub SetColors
  gosub Initialize
  gosub Demo
end
//==================================================
sub Control(cc,&x)
   bx=550 \ by=300 \ w=640/3 \ h=480/3
   CaptureImage()
   reSizeBmp "",w,h,"TempFile"
   ReadBMP "TempFile",bx,by
   // see if selected color is within view
   searchClr = cc
   BmpFindClr "",searchClr,Found,SecCnt,.05,.05,10,CntInfo
   // if found, track that one color
   if Found > -1
       // look toward the object based on its position
       x = Found#10 // the horizontal position (0-9)
       y = Found/10 // the vertical position (0-9)
       erectangle bx+(x*w/10),by+(y*h/10),bx+\
          (x*w/10+(w/10)),by+(y*h/10+(h/10)),2,White
    endif
    flip
return

//------------------------------------------------------
SetColors:
  Print "First, choose camera and set its resolution"
  CaptureSrc()  \ CaptureDlg() \ clearscr
  Print "The robot 'eyes' will recognize a selected color"
  Print
  Print "The object should have a unique color compared to the background"
  Print
  Print "Be prepared to hold your object in front of the camera"
  Print "After taking a picture of the object, you will be asked to click it"
  Print "    with the mouse (to identify the color to be searched for)."
  Print
  Print "Press ENTER to start the countdown to take a picture"
  Input "Press ENTER",i
  For i = 3 to 0
    delay 1000 \  clearscr
    XYText 400,300,i,"Times New Roman",50,fs_Bold
  next
  CaptureImage()  \ FitCB
  repeat
    ReadMouse x,y,b
  until b ==1
  delay 100 \ ReadPixel x,y,cc \ print cc
return

