//----------TCPS_Calculator.Bas-----------
MainProgram:
  GoSub Initialization
  while true
    repeat //--wait for at least 13 bytes 1+4+8
      SetEdit "Status",TCPS_Status()
    until TCPS_BuffCount() >=13
    delay 100  //--allow time for rest 
               //of bytes to arrive
    s = TCPS_Read()
    B = BuffReadB(s,0)    //--extract a byte
    I = BuffReadI(s,1)    //--extract integer 4 bytes
    F = BuffReadF(s,5)    //--extract float 8 bytes
    T = BuffRead(s,13,-1) //--extract the text 
                          //the rest of it
    xyText 120,200,B,,14,fs_Bold
    xyText 120,230,I,,14,fs_Bold
    xyText 120,260,F,,14,fs_Bold
    xyText 120,290,T,,14,fs_Bold
    s = "" 
    BuffPrintB s,toByte(B+1),I+1,F+1,Upper(T)
    TCPS_Send(s)  //--send the buffer (s)
  wend
End

Initialization:
  xyText 0,10,Center(FileNAme(ProgName()),\
             " ",45),,20,fs_Bold
  line 0,43,800,43,3
  xyText 10,50,"Local IP   = "+\
                TCP_LocalIP(),,14,fs_Bold
  xyText 10,75,"Local Port = ",,14,fs_Bold
  AddEdit "Local Port",145,75,50,0,47000 
  IntegerEdit "Local Port"
  AddEdit "Status",10,110,250
  AddButton "Serve",230,75
  repeat //wait until user pushes the button
  until LastButton() != ""
  //start server
  TCPS_Serve(ToNumber(GetEdit("Local Port")))
  RemoveButton "Serve" 
  enableEdit "Local Port",false
  xytext 120,170,"Received Data","",14,fs_Bold
  xytext 10,200,"   Byte:",,14,fs_Bold
  xytext 10,230,"Integer:",,14,fs_Bold
  xytext 10,260,"  Float:",,14,fs_Bold
  xytext 10,290,"   Text:",,14,fs_Bold
Return
