//----------UDP_UserIO.Bas-----------
MainProgram:
  GoSub Initialization
  while true
    if LastButton() != "" then GoSub SendData
    SetEdit "Status",UDP_Status("U1")
  wend
End

Initialization:
  xyText 0,10,Center(FileNAme(ProgName()),\
                " ",45),,20,fs_Bold
  line 0,43,800,43,3
  xyText 10,50,"Local IP   = "+\
               TCP_LocalIP(),,14,fs_Bold
  xyText 10,75,"Local Port = ",,14,fs_Bold
  AddEdit "Local Port",145,75,50,0,47000 
  IntegerEdit "Local Port"
  AddButton "Start Socket",230,75
  AddEdit "Status",10,110,250
  repeat //wait until user pushes the button
  until LastButton() != ""
  UDP_Start("U1",ToNumber(GetEdit("Local Port"))) 
  RemoveButton "Start Socket" 
  EnableEdit "Local Port",false
  xyText 350,50,"Remote IP  =",,14,fs_Bold
  xyText 350,75,"Remote Port=",,14,fs_Bold
  AddEdit "Remote IP",500,50,100,0,TCP_LocalIP()
  AddEdit "Remote Port",500,75,50,0,45000 
  IntegerEdit "Remote Port"
  xytext 10,200,"   Byte:          +1 =",\
             ,14,fs_Bold
  xytext 10,230,"Integer:          +1 =",\
             ,14,fs_Bold
  xytext 10,260,"  Float:          +1 =",\
             ,14,fs_Bold
  xytext 10,290,"   Text:",,14,fs_Bold
  xytext 500,260,"   Result",,14,fs_Bold
  AddEdit "Byte",100,200 \ IntegerEdit "Byte"
  AddEdit "ByteRes",270,200 \ ReadOnlyEdit "ByteRes"
  AddEdit "Integer",100,230 \ IntegerEdit "Integer"
  AddEdit "IntegerRes",270,230
  ReadOnlyEdit "IntegerRes"
  AddEdit "Float",100,260 \ FloatEdit "Float"
  AddEdit "FloatRes",270,260 
  ReadOnlyEdit "FloatRes"
  AddEdit "Text",100,290,300
  AddEdit "TextRes",420,290,300 
  ReadOnlyEdit "TextRes"
  AddButton "Send",420,220,100
Return

SendData:
  EnableButton "Send",false
  B = toByte(ToNumber(GetEdit("Byte"),0)) 
  SetEdit "Byte",Ascii(B)
  I = ToNumber(GetEdit("Integer"),0)
  F = ToNumber(GetEdit("Float"),0)*1.0 
  // 1.0 ensures a float
  T = GetEdit("Text")
  s = "" \ BuffPrintB s,B,I,F,T //--create the buffer
  UDP_Read("U1")   //--clear buffer by reading it
  RIP = GetEdit("Remote IP")
  RP = ToNumber(GetEdit("Remote Port"),1)
  UDP_Send("U1",s,RIP,RP)  //--send the buffer
  repeat //--wait for at least 13 bytes (1+4+8)
    SetEdit "Status",UDP_Status("U1")
  until UDP_BuffCount("U1") >=13
  delay 100 //--allow any more bytes time to arrive
  SetEdit "Status",UDP_Status("U1")
  s = UDP_Read("U1") //--read them
  SetEdit "ByteRes", BuffReadB(s,0) // extract a byte
  // extract 4 byte integer
  SetEdit "IntegerRes",BuffReadI(s,1) 
  // extract 8 byte float
  SetEdit "FloatRes",BuffReadF(s,5) 
  // extract the text
  SetEDit "TextRes",BuffRead(s,13,-1) 
  EnableButton "Send"
Return
