//----------UDP_Calculator.Bas-----------
MainProgram:
  GoSub Initialization
  while true
    repeat //--wait for at least 13 bytes 1+4+8
      SetEdit "Status",UDP_Status("U1")
    until UDP_BuffCount("U1") >= 13
    delay 100 //--allow time for rest of bytes 
    s = UDP_REad("U1")
    B = BuffReadB(s,0) //--extract a byte
    I = BuffReadI(s,1) //--extract integer 4 bytes
    F = BuffReadF(s,5) //--extract float 8 bytes
    T = BuffRead(s,13,-1) //--extract the rest
    xyText 120,200,B,,14,fs_Bold
    xyText 120,230,I,,14,fs_Bold
    xyText 120,260,F,,14,fs_Bold
    xyText 120,290,T,,14,fs_Bold
    s = ""  // now create the buffer
    BuffPrintB s,toByte(B+1),I+1,F+1,Upper(T) 
    RIP = GetEdit("Remote IP") 
    RP = ToNumber(GetEdit("Remote Port"),1)
    UDP_Send("U1",s,RIP,RP)  //--send the buffer
  wend
End

Initialization:
  xyText 0,10,Center(FileNAme(ProgName()),\
         " ",45),,20,fs_Bold
  line 0,43,800,43,3
  xyText 10,50,"Local IP   = "+\
              TCP_LocalIP(),,14,fs_Bold
  xyText 10,75,"Local Port = ",,14,fs_Bold
  AddEdit "Local Port",145,75,50,0,45000 
  IntegerEdit "Local Port"
  AddEdit "Status",10,110,250
  xyText 350,50,"Remote IP  =",,14,fs_Bold
  xyText 350,75,"Remote Port=",,14,fs_Bold
  AddEdit "Remote IP",500,50,100,0,TCP_LocalIP()
  AddEdit "Remote Port",500,75,50,0,47000 
  IntegerEdit "Remote Port"
  AddButton "Start Socket",230,75
  repeat //wait until user pushes the button
  until LastButton() != ""
  // now start the socket
  UDP_Start("U1",ToNumber(GetEdit("Local Port"))) 
  RemoveButton "Start Socket" 
  enableEdit "Local Port",false
  xytext 120,170,"Received Data",,14,fs_Bold
  xytext 10,200,"   Byte:",,14,fs_Bold
  xytext 10,230,"Integer:",,14,fs_Bold
  xytext 10,260,"  Float:",,14,fs_Bold
  xytext 10,290,"   Text:",,14,fs_Bold
Return
