if usbm_DllSpecs() != "" 
  if usbm_FindDevices() 
    //---there is a device and we will use device 0 
    usbm_DirectionA(0,0,0)  // set port A0 to A7 
                                 //as inputs
    usbm_DirectionB(0,0xFF,0xFF) //set port B0 to B7
                                 //as outputs
    xyText 10,10,"Set Output Port Status:" \
                  ,,20,fs_Bold|fs_Underlined 
    for i=0 to 2 
      addcheckbox ""+i,430+20*(2-i),20," " 
    next 
    xyText 90,70,"Input Port Status:" \
                 ,,20,fs_Bold|fs_Underlined
    rectangle 425,70,493,108
    while true 
      for i=0 to 2 
        if getcheckbox(""+i) // see if each box is
                             // checked
          usbm_SetBit(0,8+i) //add 8 for 
                                 //Port B bits 
        else 
          usbm_ResetBit(0,8+i) 
        endif 
      next
      // the following is done individually to
      // clarify each task
      n= usbm_ReadA(0)   // read the port
      n= n bXor 7        // invert lower three bits
      n= bin(n,3)        // convert to a binary
                         //     string
      // note: all the above can be done in one line 
       //n = bin(usbm_ReadA(0)@ 7,3)
      xyText 437,75,n,,20,fs_Bold 
    wend
  else 
    print "There are no Devices" 
  endif
else 
  print "The USBmicro DLL is not installed" 
endif
