MainProgram:
  gosub SetColors
  gosub Initialize
  gosub Demo
end
//==================================================
Demo:
  SetColor Black,BG
  print
  print
  print spaces(28)+"SERVO MOTOR SIMULATION"
  print
  print " This program simulates a servo motor",
  print " which can be moved to specific positions"
  print " by sending it pulses between 1000 and 2000",
  print " microseconds.  You do this by setting the"
  print " variable PulseWidth to the desired number and",
  print " calling the subroutine Servo.  As the"
  print " motor moves, it moves two eyes that will follow",
  print " the object being held.  You will see"
  print " a picture on the screen of what the 'eyes' are",
  print " seeing (it will be like looking in a"
  print " mirror though (when the object is on the right",
  print " side of the picture, it is on the left"
  print " side as viewed by the eyes.  A small square",
  print " will show you where the program thinks"
  print " it is seeing the object.  If it is wrong",
  print " consistently, you need an object with a more"
  print " distinct color."

// now control the servo based on the image
  while true
    call Control(cc,xPosition) // examine the image
                               // and move the motor
    PulseWidth = 2000-(xPosition*100)-100
    gosub Servo
  wend
return

